searchNodes=[{"doc":"View helper functions for Phoenix and Flop. Pagination Flop.meta/3 returns a Flop.Meta struct, which holds information such as the total item count, the total page count, the current page etc. This is all you need to render pagination links. Flop.run/3 , Flop.validate_and_run/3 and Flop.validate_and_run!/3 all return the query results alongside the meta information. If you set up your context as described in the Flop documentation , you will have a list function similar to the following: @spec list_pets ( Flop . t ( ) | map ) :: { :ok , { [ Pet . t ( ) ] , Flop.Meta . t } } | { :error , Changeset . t ( ) } def list_pets ( flop \\\\ %{ } ) do Flop . validate_and_run ( Pet , flop , for : Pet ) end Controller You can call this function from your controller to get both the data and the meta data and pass both to your template. defmodule MyAppWeb.PetController do use MyAppWeb , :controller alias Flop alias MyApp.Pets alias MyApp.Pets.Pet action_fallback MyAppWeb.FallbackController def index ( conn , params ) do with { :ok , { pets , meta } } &lt;- Pets . list_pets ( params ) do render ( conn , &quot;index.html&quot; , meta : meta , pets : pets ) end end end View To make the Flop.Phoenix functions available in all templates, locate the view_helpers/0 macro in my_app_web.ex and add another import statement: defp view_helpers do quote do # ... import Flop.Phoenix # ... end end Template In your index template, you can now add pagination links like this: &lt; h1 &gt; Listing Pets &lt; / h1 &gt; &lt; table &gt; # ... &lt; / table &gt; &lt; % = pagination ( @meta , &amp; Routes . pet_path / 3 , [ @conn , :index ] ) % &gt; The second argument of Flop.Phoenix.pagination/4 is the route helper function, and the third argument is a list of arguments for that route helper. If you want to add path parameters, you can do that like this: &lt; % = pagination ( @meta , &amp; Routes . owner_pet_path / 4 , [ @conn , :index , @owner ] ) % &gt; Customization Flop.Phoenix sets some default classes and aria attributes. &lt; nav aria - label = &quot;pagination&quot; class = &quot;pagination is-centered&quot; role = &quot;navigation&quot; &gt; &lt; span class = &quot;pagination-previous&quot; disabled = &quot;disabled&quot; &gt; Previous &lt; / span &gt; &lt; a class = &quot;pagination-next&quot; href = &quot;/pets?page=2&amp;amp;page_size=10&quot; &gt; Next &lt; / a &gt; &lt; ul class = &quot;pagination-list&quot; &gt; &lt; li &gt; &lt; span class = &quot;pagination-ellipsis&quot; &gt; &amp; hellip ; &lt; / span &gt; &lt; / li &gt; &lt; li &gt; &lt; a aria - current = &quot;page&quot; aria - label = &quot;Goto page 1&quot; class = &quot;pagination-link is-current&quot; href = &quot;/pets?page=1&amp;amp;page_size=10&quot; &gt; 1 &lt; / a &gt; &lt; / li &gt; &lt; li &gt; &lt; a aria - label = &quot;Goto page 2&quot; class = &quot;pagination-link&quot; href = &quot;/pets?page=2&amp;amp;page_size=10&quot; &gt; 2 &lt; / a &gt; &lt; / li &gt; &lt; li &gt; &lt; a aria - label = &quot;Goto page 3&quot; class = &quot;pagination-link&quot; href = &quot;/pets?page=3&amp;amp;page_size=2&quot; &gt; 3 &lt; / a &gt; &lt; / li &gt; &lt; li &gt; &lt; span class = &quot;pagination-ellipsis&quot; &gt; &amp; hellip ; &lt; / span &gt; &lt; / li &gt; &lt; / ul &gt; &lt; / nav &gt; You can customize the css classes and add additional HTML attributes. It is recommended to set up the customization once in a view helper module, so that your templates aren't cluttered with options. Create a new file called views/flop_helpers.ex : defmodule MyAppWeb.FlopHelpers do use Phoenix.HTML def pagination ( meta , path_helper , path_helper_args ) do Flop.Phoenix . pagination ( meta , path_helper , path_helper_args , pagination_opts ( ) ) end def pagination_opts do [ # ... ] end end Change the import in my_app_web.ex : defp view_helpers do quote do # ... import MyAppWeb.FlopHelpers # ... end end Page link options By default, page links for all pages are show. You can limit the number of page links or disable them altogether by passing the :page_links option. :all : Show all page links (default). :hide : Don't show any page links. Only the previous/next links will be shown. {:ellipsis, x} : Limits the number of page links. The first and last page are always displayed. The x refers to the number of additional page links to show. Attributes and CSS classes You can overwrite the default attributes of the &lt;nav&gt; tag and the pagination links by passing these options: :wrapper_attrs : attributes for the &lt;nav&gt; tag :previous_link_attrs : attributes for the previous link ( &lt;a&gt; if active, &lt;span&gt; if disabled) :next_link_attrs : attributes for the next link ( &lt;a&gt; if active, &lt;span&gt; if disabled) :pagination_list_attrs : attributes for the page link list ( &lt;ul&gt; ) :pagination_link_attrs : attributes for the page links ( &lt;a&gt; ) :ellipsis_attrs : attributes for the ellipsis element ( &lt;span&gt; ) :ellipsis_content : content for the ellipsis element ( &lt;span&gt; ) Pagination link aria label For the page links, there is the :pagination_link_aria_label option to set the aria label. Since the page number is usually part of the aria label, you need to pass a function that takes the page number as an integer and returns the label as a string. The default is &amp;&quot;Goto page \#{&amp;1}&quot; . Previous/next links By default, the previous and next links contain the texts Previous and Next . To change this, you can pass the :previous_link_content and :next_link_content options. Customization example def pagination ( meta , path_helper , path_helper_args ) do opts = [ ellipsis_attrs : [ class : &quot;ellipsis&quot; ] , ellipsis_content : &quot;‥&quot; , next_link_attrs : [ class : &quot;next&quot; ] , next_link_content : next_icon ( ) , page_links : { :ellipsis , 7 } , pagination_link_aria_label : &amp; &quot; \#{ &amp;1 } ページ目へ&quot; , pagination_link_attrs : [ class : &quot;page-link&quot; ] , pagination_list_attrs : [ class : &quot;page-links&quot; ] , previous_link_attrs : [ class : &quot;prev&quot; ] , previous_link_content : previous_icon ( ) , wrapper_attrs : [ class : &quot;paginator&quot; ] ] Flop.Phoenix . pagination ( meta , path_helper , path_helper_args , opts ) end defp next_icon do tag :i , class : &quot;fas fa-chevron-right&quot; end defp previous_icon do tag :i , class : &quot;fas fa-chevron-left&quot; end Sortable table To add a sortable table for pets on the same page, define a function in MyAppWeb.PetView that returns the table headers: def table_headers do [ &quot;ID&quot; , { &quot;Name&quot; , :name } , { &quot;Age&quot; , :age } , &quot;&quot; ] end This defines four header columns: One for the ID, which is not sortable, and columns for the name and the age, which are both sortable, and a fourth column without a header value. The last column will hold the links to the detail pages. The name and age column headers will be linked, so that they the order on the :name and :age field, respectively. Next, we define a function that returns the column values for a single pet: def table_row ( % Pet { id : id , name : name , age : age } , opts ) do conn = Keyword . fetch! ( opts , :conn ) [ id , name , age , link ( &quot;show&quot; , to : Routes . pet_path ( conn , :show , id ) ) ] end The controller already assigns the pets and the meta struct to the conn. All that's left to do is to add the table to the index template: &lt; % = table ( %{ items : @pets , meta : @meta , path_helper : &amp; Routes . pet_path / 3 , path_helper_args : [ @conn , :index ] , headers : table_headers ( ) , row_func : &amp; table_row / 2 , opts : [ conn : @conn ] } ) % &gt; LiveView The functions in this module can be used in both .eex and .leex templates. Links are generated with Phoenix.LiveView.Helpers.live_patch/2 . This will lead to &lt;a&gt; tags with data-phx-link and data-phx-link-state attributes, which will be ignored in .eex templates. When used in LiveView templates, you will need to handle the new params in the handle_params/3 callback of your LiveView module.","ref":"Flop.Phoenix.html","title":"Flop.Phoenix","type":"module"},{"doc":"Takes a Phoenix path helper function and a list of path helper arguments and builds a path that includes query parameters for the given Flop struct. Examples iex&gt; pet_path = fn _conn , :index , query -&gt; ...&gt; &quot;/pets?&quot; &lt;&gt; Plug.Conn.Query . encode ( query ) ...&gt; end iex&gt; flop = % Flop { page : 2 , page_size : 10 } iex&gt; build_path ( pet_path , [ % Plug.Conn { } , :index ] , flop ) &quot;/pets?page_size=10&amp;page=2&quot; We're defining fake path helpers for the scope of the doctests. In a real Phoenix application, you would pass something like &amp;Routes.pet_path/3 as the first argument. You can also pass a Flop.Meta struct or a keyword list as the third argument. iex&gt; pet_path = fn _conn , :index , query -&gt; ...&gt; &quot;/pets?&quot; &lt;&gt; Plug.Conn.Query . encode ( query ) ...&gt; end iex&gt; flop = % Flop { page : 2 , page_size : 10 } iex&gt; meta = % Flop.Meta { flop : flop } iex&gt; build_path ( pet_path , [ % Plug.Conn { } , :index ] , meta ) &quot;/pets?page_size=10&amp;page=2&quot; iex&gt; query_params = to_query ( flop ) iex&gt; build_path ( pet_path , [ % Plug.Conn { } , :index ] , query_params ) &quot;/pets?page_size=10&amp;page=2&quot; If the path helper takes additional path parameters, just add them to the second argument. iex&gt; user_pet_path = fn _conn , :index , id , query -&gt; ...&gt; &quot;/users/ \#{ id } /pets?&quot; &lt;&gt; Plug.Conn.Query . encode ( query ) ...&gt; end iex&gt; flop = % Flop { page : 2 , page_size : 10 } iex&gt; build_path ( user_pet_path , [ % Plug.Conn { } , :index , 123 ] , flop ) &quot;/users/123/pets?page_size=10&amp;page=2&quot; If the last path helper argument is a query parameter list, the Flop parameters are merged into it. iex&gt; pet_url = fn _conn , :index , query -&gt; ...&gt; &quot;https://pets.flop/pets?&quot; &lt;&gt; Plug.Conn.Query . encode ( query ) ...&gt; end iex&gt; flop = % Flop { order_by : :name , order_directions : [ :desc ] } iex&gt; build_path ( pet_url , [ % Plug.Conn { } , :index , [ user_id : 123 ] ] , flop ) &quot;https://pets.flop/pets?user_id=123&amp;order_directions[]=desc&amp;order_by=name&quot; iex&gt; build_path ( ...&gt; pet_url , ...&gt; [ % Plug.Conn { } , :index , [ category : &quot;small&quot; , user_id : 123 ] ] , ...&gt; flop ...&gt; ) &quot;https://pets.flop/pets?category=small&amp;user_id=123&amp;order_directions[]=desc&amp;order_by=name&quot;","ref":"Flop.Phoenix.html#build_path/3","title":"Flop.Phoenix.build_path/3","type":"function"},{"doc":"Generates a pagination element. meta : The meta information of the query as returned by the Flop query functions. path_helper : The path helper function that builds a path to the current page, e.g. &amp;Routes.pet_path/3 . path_helper_args : The arguments to be passed to the route helper function, e.g. [@conn, :index] . The page number and page size will be added as query parameters. opts : Options to customize the pagination. See section Customization. See the module documentation for examples.","ref":"Flop.Phoenix.html#pagination/4","title":"Flop.Phoenix.pagination/4","type":"function"},{"doc":"Generates a table with sortable columns. The argument is a map with the following keys: headers : A list of header columns. Can be a list of strings (or markup), or a list of {value, field_name} tuples. items : The list of items to be displayed in rows. This is the result list returned by the query. meta : The Flop.Meta struct returned by the query function. path_helper : The Phoenix path or url helper that leads to the current page. path_helper_args : The argument list for the path helper. For example, if you would call Routes.pet_path(@conn, :index) to generate the path for the current page, this would be [@conn, :index] . opts : Keyword list with additional options (see below). This list will also be passed as the second argument to the row function. row_func : A function that takes one item of the items list and the opts and returns the column values for that item's row. Available options :for - The schema module deriving Flop.Schema . If set, header links are only added for fields that are defined as sortable. :table_class - The CSS class for the &lt;table&gt; element. No default. :symbol_class - The CSS class for the &lt;span&gt; element that wraps the order direction indicator in the header columns. Defaults to &quot;order-direction&quot; . :symbol_asc - The symbol that is used to indicate that the column is sorted in ascending order. Defaults to &quot;▴&quot; . :symbol_desc - The symbol that is used to indicate that the column is sorted in ascending order. Defaults to &quot;▾&quot; . :container - Wraps the table in a &lt;div&gt; if true . Defaults to false . :container_class - The CSS class for the table container. Defaults to &quot;table-container&quot; . See the module documentation for examples.","ref":"Flop.Phoenix.html#table/1","title":"Flop.Phoenix.table/1","type":"function"},{"doc":"Converts a Flop struct into a keyword list that can be used as a query with Phoenix route helper functions. Examples iex&gt; to_query ( % Flop { } ) [ ] iex&gt; f = % Flop { order_by : [ :name , :age ] , order_directions : [ :desc , :asc ] } iex&gt; to_query ( f ) [ order_directions : [ :desc , :asc ] , order_by : [ :name , :age ] ] iex&gt; f |&gt; to_query |&gt; Plug.Conn.Query . encode ( ) &quot;order_directions[]=desc&amp;order_directions[]=asc&amp;order_by[]=name&amp;order_by[]=age&quot; iex&gt; f = % Flop { page : 5 , page_size : 20 } iex&gt; to_query ( f ) [ page_size : 20 , page : 5 ] iex&gt; f = % Flop { first : 20 , after : &quot;g3QAAAABZAAEbmFtZW0AAAAFQXBwbGU=&quot; } iex&gt; to_query ( f ) [ first : 20 , after : &quot;g3QAAAABZAAEbmFtZW0AAAAFQXBwbGU=&quot; ] iex&gt; f = % Flop { ...&gt; filters : [ ...&gt; % Flop.Filter { field : :name , op : :=~ , value : &quot;Mag&quot; } , ...&gt; % Flop.Filter { field : :age , op : :&gt; , value : 25 } ...&gt; ] ...&gt; } iex&gt; to_query ( f ) [ filters : %{ 0 =&gt; %{ field : :name , op : :=~ , value : &quot;Mag&quot; } , 1 =&gt; %{ field : :age , op : :&gt; , value : 25 } } ] iex&gt; f |&gt; to_query ( ) |&gt; Plug.Conn.Query . encode ( ) &quot;filters[0][field]=name&amp;filters[0][op]=%3D~&amp;filters[0][value]=Mag&amp;filters[1][field]=age&amp;filters[1][op]=%3E&amp;filters[1][value]=25&quot;","ref":"Flop.Phoenix.html#to_query/1","title":"Flop.Phoenix.to_query/1","type":"function"},{"doc":"Flop Phoenix Flop Phoenix is an Elixir library for filtering, ordering and pagination with Ecto, Phoenix and Flop .","ref":"readme.html","title":"Flop Phoenix","type":"extras"},{"doc":"Add flop_phoenix to your list of dependencies in the mix.exs of your Phoenix application: def deps do [ { :flop_phoenix , &quot;~&gt; 0.6.1&quot; } ] end Follow the instructions in the Flop documentation to set up your business logic.","ref":"readme.html#installation","title":"Flop Phoenix - Installation","type":"extras"},{"doc":"In your controller, pass the data and the Flop meta struct to your template: defmodule MyAppWeb.PetController do use MyAppWeb , :controller alias Flop alias MyApp.Pets alias MyApp.Pets.Pet action_fallback MyAppWeb.FallbackController def index ( conn , params ) do with { :ok , { pets , meta } } &lt;- Pets . list_pets ( params ) do render ( conn , &quot;index.html&quot; , meta : meta , pets : pets ) end end end In my_app_web.ex , find the view_helpers/0 macro and import Flop.Phoenix : defp view_helpers do quote do # Use all HTML functionality (forms, tags, etc) use Phoenix.HTML # Import basic rendering functionality (render, render_layout, etc) import Phoenix.View + import Flop.Phoenix import MyAppWeb.ErrorHelpers import MyAppWeb.Gettext alias MyAppWeb.Router.Helpers, as: Routes end end In your index template, you can now add pagination links: &lt; h1 &gt; Listing Pets &lt; / h1 &gt; &lt; table &gt; # ... &lt; / table &gt; &lt; % = pagination ( @meta , &amp; Routes . pet_path / 3 , [ @conn , :index ] ) % &gt; &lt; span &gt; &lt; % = link &quot;New Pet&quot; , to : Routes . pet_path ( @conn , :new ) % &gt; &lt; / span &gt; The second argument of Flop.Phoenix.pagination/4 is the route helper function, and the third argument is a list of arguments for that route helper. If you want to add path parameters, you can do that like this: &lt; % = pagination ( @meta , &amp; Routes . owner_pet_path / 4 , [ @conn , :index , @owner ] ) % &gt;","ref":"readme.html#usage","title":"Flop Phoenix - Usage","type":"extras"},{"doc":"If you want to customize the pagination markup, you would probably want to do that once for all templates. To do that, create a new file views/flop_helpers.ex . defmodule MyAppWeb.FlopHelpers do use Phoenix.HTML def pagination ( meta , route_helper , route_helper_args ) do opts = [ next_link_content : next_icon ( ) , previous_link_content : previous_icon ( ) , wrapper_attrs : [ class : &quot;paginator&quot; ] ] Flop.Phoenix . pagination ( meta , route_helper , route_helper_args , opts ) end defp next_icon do tag :i , class : &quot;fas fa-chevron-right&quot; end defp previous_icon do tag :i , class : &quot;fas fa-chevron-left&quot; end end Change the import in my_app_web.ex : defp view_helpers do quote do # ... - import Flop.Phoenix + import MyAppWeb.FlopHelpers # ... end end Refer to the Flop.Phoenix docs for more information on the available options.","ref":"readme.html#customization","title":"Flop Phoenix - Customization","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Fixed Pagination helper generated invalid links when using default_limit option.","ref":"changelog.html#0-6-1-2021-05-05","title":"Changelog - [0.6.1] - 2021-05-05","type":"extras"},{"doc":"Added Add Flop.Phoenix.table/1 for rendering sortable tables. Add function Flop.Phoenix.to_query/1 , which converts a Flop struct into a keyword list for query parameters. Add function Flop.Phoenix.build_path/3 , which applies Flop parameters to a Phoenix path helper function. Removed Remove Flop.Phoenix.Live.PaginationComponent in favor of making Flop.Phoenix.pagination/4 work in both .eex and .leex templates.","ref":"changelog.html#0-6-0-2021-05-04","title":"Changelog - [0.6.0] - 2021-05-04","type":"extras"},{"doc":"Fixed Merge pagination query parameters into existing query parameters, if present.","ref":"changelog.html#0-5-1-2021-04-14","title":"Changelog - [0.5.1] - 2021-04-14","type":"extras"},{"doc":"Changed Rename FlopPhoenix to Flop.Phoenix . Add Flop.Phoenix.Live.PaginationComponent for use with Phoenix.LiveView . Change pagination to always display links to the first and last page.","ref":"changelog.html#0-5-0-2021-03-23","title":"Changelog - [0.5.0] - 2021-03-23","type":"extras"},{"doc":"Changed Allow usage with newer versions of Flop.","ref":"changelog.html#0-4-0-2020-09-04","title":"Changelog - [0.4.0] - 2020-09-04","type":"extras"},{"doc":"Added New option to hide the number of page links. New option to limit the number of page links. Changed Add order and filter parameters to pagination links.","ref":"changelog.html#0-3-0-2020-06-17","title":"Changelog - [0.3.0] - 2020-06-17","type":"extras"},{"doc":"Added Improve documentation. Changed previous_link/3 , next_link/3 and page_links/3 are private functions now.","ref":"changelog.html#0-2-0-2020-06-15","title":"Changelog - [0.2.0] - 2020-06-15","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0-2020-06-15","title":"Changelog - [0.1.0] - 2020-06-15","type":"extras"}]